; =========================================================================================================================
       org   $2000
;
noexec equ   $10					; inhibit exec after loading (0 = NO EXEC)
dnum   equ   $12					; assigned drive number by DW4 server

sec1st equ   $76					; 1ST directory sector (2 bytes)
numsec equ   $76					; number of sectors in extent in process

dwdvet equ   $e6					; DoRead vector (2 bytes)
tabptr equ   $f7					; pointer to table entry (2 bytes)
secdon equ   $f9              ; number of directory sectors read
;
dimask equ   $50					; mask to disable interrupts(FIRQ and IRQ)
eimask equ   $af					; mask to enable interrupts
sector equ   $01cf				; next sector to be read (2 bytes)
nambuf equ   $01d1				; fixed by BASIC, read filename function which stores in $1d1
drghdr equ   nambuf				; header will be copied here
strbuf equ   nambuf+8			; beginning of circular buffer
endbuf equ   strbuf+256	 		; end of circular buffer
table  equ   $02e0            ; Table with all needed sectors for the requested file
newdes equ   $0350				; new destination for part two
header equ   $2f00            ; place where header (sector zero) is to be loaded (2F00-2FFF)
dirent equ   $3000				; where to copy the directory sector containing the entry in process
extent equ   $3100				; where to copy the directory sector with extensions for the entry in process
filnam equ   $3200				; buffer for the 'standardized' filename read from entry
;
syserr equ   $8344				; Show error message (B=error code)
basv2	 equ   $83ed				; initialize BASIC
basv1	 equ   $841f				; reset BASIC stack etc
runbas equ   $849f				; run_basic
outchr equ   $b54a				; print char A to DEVNUM
outstr equ   $90e5				; print string at X+1 to DEVNUM
getnam equ   $b7aa				; read file name and length into $1d1
ioerr  equ   $b84b				; IO ERROR message
;
entry  JSR   <$a5							; peek at next character (after "VLOAD")
       SUBA  #'N							; to detect if it was an 'N' - if so don't run/exec it
       STA   <noexec 					; save difference. 0 = noexec
 		 BNE	 nojump						; if not 'N' don't skip it
		 JSR   <$9f							; skip that 'N'
nojump BSR   jmpchr          			; see if there is an arguments separator
											; initial message and save DLOAD vectors
savvec LBSR  msg01 					   ; print initial message
       LDX   ,s							; get stack pointer ro reg 'X'
       LDU   1,x							; get 1ST address from vector table
       STU   dwrvec  					; save as vector for DWREAD
       LDU   3,x							; get 2nd address from vector table
       STU   dwwvec						; save as vector for DWWRITE
       LDU   5,x							; get 3rd address from vector table
       STU   dwdvec						; save as vector for DWDOREAD
		 stu   <dwdvet				   ; save as vector for DWDOREAD en TABLDR
											; get the VDK name (adding extension if not present)
getn   ORCC  #dimask	            	; disable FIRQ, IRQ (to work with DW4)
		 JSR   getnam						; read VDK filename and length into $1d1 = nambuf
       LDX   #nambuf-1					; byte before packet buffer start
       CLR   ,x							; zero MSB to make a 16 bit value for Y
       LDY   ,x++							; length of file name (16 bit)
       BEQ   failed						; if len=0 no file entered
       LDB   -1,x							; length of name (8 bit)
											; Adding .VDK if not termination entered      
		 PSHS  b,x							; save pointer to beginning of name and name length
isdot  LDA   ,x+							; get a char from name
       CMPA  #'.							; is it a dot?
       BEQ   alrdot						; yes, stop search, quit loop
       DECB									; decrement counter
       BNE   isdot						; not end of string, get next char
       LDD   #$2e56						; get chars ".V"
       STD   ,x++							; add to end of name
       LDD   #$444b						; get chars "DK"
       STD   ,x++							; add to end of name
		 LDB   ,s							; get old name length
		 ADDB  #4							; add 4 (because of .VDK added)
		 STB   ,s							; update new length in stack
       STB   >nambuf						; save new length in byte before string
       LEAY  4,y                    ; correction to name length - DW parameter
alrdot PULS  b,x       					; restore pointer and length
		 CLR   b,x							; zero terminate name string
											; ask DW4 to mount the VDKname or fail
       INC   ,--x							; 1 = DriveWire OP_NAMEOBJ_MOUNT command
       LEAY  2,y							; length of DW packet = name length + 2
       JSR   [dwwvec,pcr]					; send file request to server
       LDX   #dnum						; our drive number variable
       CLR   ,x							; clear it
       LEAY  1,y							; read one byte back
       JSR   [dwrvec,pcr]					; get assigned drive number
       TST   ,x							; verify received value
       BNE   vdhead						; if not zero, successful mount                                       
       LDB   #$19							; code for MO ERROR
errout ANDCC #eimask						; enable interrupts
		 JMP   syserr						; show error message
											; Messages Dispatcher
jmpchr JSR   <$a5							; gets last read char
       CMPA  #'"							; is it a double quote?
       BEQ   jmp01						; yes, don't jump over it
       JSR   <$9f							; no, skip it
jmp01  RTS									; return
;
msg07  CLRB									; code for NF ERROR
		 BRA   errout						; show error message
msg06  LEAS	 2,s                    ; to get rid of PC put in stack by MOREXT
		 LDX   #badvdk-1              ; point to message "Bad VDK directory"
		 FCB   $10							; forms LDY #xxxx with next instruction, to jump it
msg05  LDX   #nulfil-1              ; point to message "Null File"
		 FCB   $10							; forms LDY #xxxx with next instruction, to jump it
msg04  LDX   #notdw-1					; point to error message "Not DW-adapted file"
		 FCB   $10							; forms LDY #xxxx with next instruction, to jump it
msg03  LDX   #notvdk-1					; point to error message "Not VDK file"  
  		 FCB   $10							; forms LDY #xxxx with next instruction, to jump it
msg02  LDX   #notfil-1					; point to error message "No FILE Entered"  
       ANDCC #eimask						; enable interrupts
  		 FCB   $10							; forms LDY #xxxx with next instruction, to jump it
msg01  LDX   #ldtext-1					; point to intro message
       JSR   outstr						; print message to screen
		 RTS									; return
;
failed ANDCC #eimask						; enable interrupts
   	 JMP   ioerr						; I/O error message
;											; treats any char different from double quote as an arguments separator and skips it
   	 									; read the VDK header and verify it is OK
vdhead LDX   #0							; header sector to be read through DW4
       LDY   #header						; point to header RAM area
       JSR   [dwdvec,pcr]					; read header
       BCS   failed						; detect frame error
       BNE   failed						; detect incomplete read operation
       LDD   #$646b                 ; first word (byte numbers 0-1) should be 'dk' (lowercase)
       CMPD  ,y                     ; is a VDK file?
       BNE   msg03				      ; no, show error (Not an VDK file)
		 LDB   2,y  						; header length. Low 8 bits come in byte 2
		 LDA   3,y                    ; header length. High 8 bits come in byte 3
		 CMPD	 #$0100						; is it a DW-adapted VDK?
       BNE   msg04						; no, show error (Not DW-adapted VDK)
											; calculate with header params the first directory sector to be read
vdk    LDX   #361							; 1st directoy sector for a 180k disk
		 LDB   9,y							; byte number 9 is number of sides (1=single for 180K - 2=double for 360k and 720k upon byte 8)
		 CMPB  #2							; is double sided?
		 BNE   notx2						; no, don't double tracks
		 LDX	 #721							; 1st directory sector for double sided disks
notx2	 LEAX  2,x							; jump over the two first sectors of the directory track (FAT)
		 STX   <sec1st						; save number of 1st directory data entry sector
											; get the filename to be loaded/executed (will stay at $1D2 with length al $1D1)
 		 BSR   jmpchr          			; see if there is an arguments separator
       JSR   getnam						; read filename to be loaded and length into $1d1 = nambuf
       LDB   >nambuf						; length of filename (8 bit)
       BEQ   msg02						; if len=0 no file entered, show message and stop

;***************************************************************************************************
; Directory entries Process: Searching the requested filename
;***************************************************************************************************
		 CLR   <secdon						; zero dir sectors read
		 LDX   #table						; get beginning of the table at RAM
		 STX   <tabptr						; save at working variable
		 CLRA									; zero
		 CLRB									; 16 bits
		 STD   ,x							; initialize table: drive 0, run flag equal true
		 STA	 4,x							; initialize table: numSects = $0
		 COMA									; convert into $FF
		 COMB									; convert into $FF
		 STD	 2,x							; initialize table: 1st LSN = $FFFF
		 LDX   <sec1st                ; get first data directory sector (track 20 sector 3)
                             			; for each data directory sector (from SEC1ST to SEC1ST+15 = 3 to 18 track 20)
nxtsec LDY   #dirent							; point to directory entries area in RAM
													; ask DW4 to load the sector
       JSR   [dwdvec,pcr]						; read directory sector
       BCS   failed							; detect frame error
       BNE   failed							; detect incomplete read operation
													; for each one of the 10 file entries
														; verify that is a valid entry, else go to next entry
       LDU   #dirent								; point to read data area
nent01 LDA   ,u									; read flags of this entry
       BITA  #8									; if Flags AND 8 = 8 then END of Directory reached
       LBNE  msg07								; if so, show error message: Not Found
       BITA  #128+1              	  		; if Flags AND 1 = 1 this is an Extension, don't use it and go to next entry
       												; or Flags AND 128 = 128 then is a Deleted File, forget about it and go to next entry
       BNE  nxtent									; if any of them go to next entry
														; got a valid file entry. Read FileName and Extension (carefull, both are right padded with nulls)
ext01a LDX   #filnam             	   	; point to standardized filename buffer in this entry
		 LDD   #$0108								; offset 1-8 = FileName
    	 BSR  savnam								; put name into buffer (skipping nulls)
       LDA   #'.									; get dot ascii code
       STA   ,x+									; add to buffer
		 LDD   #$0903								; Offset 9-11 = Extension
	 	 BSR  savnam								; add to buffer (skipping nulls)
	 	 CLR   ,x									; put a null at the end
														; compare this standardized filename against the required one
		 LDX   #filnam								; point to the beginning of read filename
		 LDY   #nambuf								; point to the beginning of required file
 		 LDB   ,y+									; get file length and point to 1st char
cmpstr LDA   ,x+									; get one char from standardized filename
		 CMPA  ,y+									; is the same than the one in required file?
		 BNE   nxtent								; no, go to next file entry
		 DECB											; decrement counter
		 BNE   cmpstr								; if more chars to compare, go back
														; coincidence found. Put DW4 assigned drive number at $200
succes LDX   #table								; point to data Table
       LDA   <dnum								; get drive number
       STA   ,x+									; save it
       LDA   <noexec								; get run/exec flag
       STA   ,x+									; add to table
										   	      ; for each extent in that file entry (four)
ext01  LDA   14,u										; is offset 14 zero (num sectors for 1st extent)?   
		 LBEQ	 msg05									; NO sectors used, stop and show error message
		            									; add used sectors by this file
       LDB   #14										; offset to number of sectors in 1st extent
extlop SUBB  #2										; offset to 1st sector LSN
		 LDY   b,u										; get LSN
    	 LEAY  1,y										; because header occupies a whole sector in VDK!		 
		 STY   ,x++										; put LSN in table
		 STA   ,x+										; put numSects in table
		 ADDB  #5										; gives offset to number of sectors in next extent	 CMPB  #23										
		                                 ; is it out of limits (past 4th extent)?
		 CMPB  #23										; is it out of limits (past 4th extent)?
		 BHI   ext04a									; yes, out of this extents loop
		 LDA   b,u         							; is number of sectors in next extent equal to zero?
       BNE   extlop										; no, back to process next extent
       BRA   calnxt									; out to call next dweeb
		 											; see if there are more extents to analyze
ext04a STX   <tabptr								; save tabpointer
		 LDA	 ,u									; get Flags of this entry
       BITA  #32									; if Flags AND 32 = 32 there are more extents
       BEQ   calnxt              	   	; else out of here to call next dweeb
 		 BSR	 morext 								   ; call MoreExtents(Offset 24)
		 BRA   calnxt								   ; out to call next dweeb
;
nxtent LEAU  25,u				 					; point to next entry - (step 25 bytes)
       CMPU  #dirent+250						; detected end of sector entries?
       BLO   nent01							; no, process next file entry
       INC   <secdon							; increment number of dir sectors processed
       LDB   <secdon							; get this value
       CMPB  #16                 	   ; finished whole directory? (from 3 to 18, so 16 data sectors)
       LBHS  msg07							; yes, error message File Not Found
		 LDX   <sec1st		 					; get first directory sector
		 ABX										; add sector number to be processed
       LBRA	 nxtsec						; process next directory sector
       
;***************************************************************************************************
; Adds name or extension to the filename buffer pointed by X  -  U = points to sector entry
; A contains offset to beginning of text - B contains length of data to be copied
;***************************************************************************************************
savnam LEAY  a,u							; point to data from sector entry plus offset
add01  LDA   ,y+							; get a byte
		 BEQ   noadd						; if null, quit
       STA   ,x+							; add to buffer
		 DECB									; decrement counter
	    BNE   add01						; not all done, keep on
noadd  RTS									; return

;***************************************************************************************************
; pass control to embedded TABLDR
;***************************************************************************************************
calnxt LDD   #$ffff						; end record mark: LSN number ($FFFF)  
		 STD   ,x++							; put at the end of table data
		 CLR   ,x+							; end record mark: sectors used ($00)
		 LBRA  tabldr						; jumps to TABLDR

;***************************************************************************************************
; Process extra extents (additional ones). Called with U pointing to old entry 
;***************************************************************************************************
morext LDA   24,u							; get offset 24 as input (next entry to use)
		 CLRB      							; first directory sector
mor01  SUBA  #10							; subtract 10 entries (1 sector)
		 BMI   mor02						; if negative value, adapt result
		 INCB									; increment sector number
		 BRA   mor01						; keep on subtracting
mor02	 ADDA  #10							; to get a positive value = entry number where the extents begin	 
       LDU   #extent						; point to beginning of read data area for extents
		 LDX   <sec1st						; get first directory sector
		 ABX									; add calculated sector
		 LDB   #25							; entry length
		 MUL									; space to jump over (A was entry to find in the calculated sector)
		 LEAU  d,u							; U points to first byte of desired extents entry (in buffer area)
		 LDY   #extent						; point to extent entries area in RAM
       JSR   [dwdvec,pcr]					; read directory sector
       BCS   mfail						; detect frame error
       BNE   mfail						; detect incomplete read operation
		 LDA   ,u							; get entry flags (fisrt byte of entry)										
       BITA	 #1							; Flags (offset 0) AND 1 must be equal to 1 (extent entry)
       LBEQ  msg06						; else we have a problem and must quit program
                              		; For each of the 7 extents in this entry
       LDB   #3								; offset to number of sectors for 1st extent
       LDX   <tabptr							; get Table pointer back
mor03  LDA   b,u 								; is number of sectors = 0?
       BEQ   mor05							; yes, return
		 SUBB  #2								; offset to 1st LSN
 		 LDY   b,u								; get the 1st LSN of the extent
    	 LEAY  1,y								; because header occupies a whole sector in VDK!		 
 		 STY   ,x++								; put int table
 		 STA   ,x+								; add to table
mor04	 ADDB  #2+3								; point to next extent - 2 bytes to compensate for prior SUBB (step 3 bytes)
		 CMPB  #22								; out of range?
		 BLO   mor03						; no, process next extent
		 STX   <tabptr						; save pointer to table
 		 LDA   ,u							; get entry flags
 		 BITA  #32							; entry flags AND 32 = 32? 
		 BNE   morext						; yes, there are more extents, go back to process them
mor05	 RTS						   		; return
mfail  LEAS  2,s  						; clean stack
 	 	 ANDCC #eimask						; enable interrupts
		 JMP   ioerr						; I/O error message
	 
;***************************************************************************************************
;
ldtext FCC   /LOAD A FILE FROM AN VDK/
       FCB   13,0							; intro message to the user
notvdk FCN   /NOT AN VDK FILE/		; bad VDK file
notdw  FCN   /VDK NOT FOR DW/		   ; VDK not adapted for DW
badvdk FCN   /BAD VDK DIRECTORY/		; Bad directory entry
nulfil FCN   /NULL FILE/            ; 0 bytes length file
notfil FCN   /NO FILE ENTERED/      ; No File entered
;
dwrvec FDB   0								; indirect jump to drivewire read function
dwwvec FDB   0								; indirect jump to drivewire write function 
dwdvec FDB   0								; indirect jump to drivewire doread function
;
;***************************************************************************************************

tabldr	ldx   #dwtext-1			; message table loader
			jsr   outstr				; print string
			ldx   #table				; point to beginning of table
			lda   ,x+					; get drive number
			beq   msgt2             ; show message: "No drive number" and quit
			sta   <dnum					; save drive number 
			lda   ,x+					; get run/exec flag
			sta	<noexec				; save run/exec flag
			ldd   ,x++					; get first LSN
			std   >sector				; put in working variable
			lda   ,x+					; get number of sectors in this extent
			sta   <numsec				; put in working variable
			stx   <tabptr				; save pointer to table
;
			orcc	#dimask				; disable interrupts to work with DW4
			ldu   #endbuf    			; point to end of buffer (start with empty buffer)
         ldy   #9						; read 9 bytes (Dragon header)
			ldx   #drghdr   			; header destination
			lbsr  cpybuf    			; moves x bytes ahead
										; verify the header we just read		
			lda   -9,x       			; get first data byte
			cmpa  #$55       			; Dragon DOS file?
			bne   msgt1					; show message: "Not a Dragon file" and quit
;			
        	pshs  d,x,u					; save registers
			ldx   #sndprt				; point to reallocatable part
			ldu   #newdes  			; point to new destination
realoc   ldd   ,x++					; get 2 bytes
			std   ,u++					; copy to destination
			cmpx  #endpgm				; got to end?
			bls   realoc				; no, keep on
         puls  d,x,u				; restore registers
         jmp   newdes 				; transfer control to reallocated part
;
msgt2    ldx   #nodrvn-1         ; point to message No drive Number
			fcb   $10               ; to jump over next one (forming a ldy #$nnnn)
msgt1    ldx   #notdf-1				; point to message Not Dragon file
			jsr   outstr				; show it to screen
         ldx   #$02dc				; beginning of interpreters buffer
			stx   <$a6					; get nextchar points to it
			clra							; zero
			clrb							; 16 bits
			std   ,x						; clean buffer
      	andcc #eimask				; enable interrupts			
			rts							; return to the caller (and from there to the interpreter)			
;
dwtext	FCC   /FILE LOADER/
			FCB   13,0						; initial message
notdf    FCN   /NOT A DRAGON FILE/	; not Dragon file
nodrvn   FCN   /NO DRIVE NUMBER/		; no drive number received
;
;
;***************************************************************************************************
; SECOND PART OF PROGRAM - TO BE REALLOCATED BELOW $0400
;***************************************************************************************************
sndprt	dec   -8,x       			; decrement file type (Dragon DOS BASIC is 1)
			bne   ddbin					; if not zero it was a 2, so binary file
ldbas		ldy   -5,x       			; get file length (read whole BASIC program)
			ldx   <$19					; get start of basic
			bsr   cpybuf				; read whole file ... sectors are in Table !
basptr	stx   <$1b       			; start for simple variables
			stx   <$1d					; start for array variables
			stx   <$1f					; end of storage in use
			jsr   basv2    			; BasVect2 initialize BASIC
			tst   <noexec				; should it be run?
			beq   msgou2					; no, go out
			jsr   basv1    			; BasVect1 reset BASIC stack etc
			jmp   runbas				; run basic
;
ddbin		ldy   -5,x       			; file length					
			ldx   -7,x       			; load address
			bsr   cpybuf    			; read whole file ... sectors are in Table !
			ldx   #drghdr+6 			; point to exec address
			ldx   ,x       			; get exec address
			tfr   x,d					; transfer to D
			inca							; test address range
			beq   msgou2				; return to basic command loop if exec address $FFxx
			stx   <$9d       			; save BASIC EXEC address
			tst   <noexec				; should be executed?
			beq	msgou2				; no, don't do it
      	andcc #eimask				; enable interrupts			
			jsr   ,x						; exec it
			rts							; return
;			
msgt3    leas	6,s					; clean stack
			ldx   #endtab-1			; point to message End of Table
			jsr   outstr				; show it to screen
msgou2   ldx   #$02dc				; beginning of interpreters buffer
			stx   <$a6					; get nextchar points to it
			clra							; zero
			clrb							; 16 bits
			std   ,x						; clean buffer
      	andcc #eimask				; enable interrupts			
			rts							; return to the caller (and from there to the interpreter)
;
errdw    leas  6,s					; clean stack
			bra   msgou2				; back to the caller
;
;***************************************************************************************************
; Works with a circular buffer. U must point to the buffer
; Y is the required number of bytes to be read (will read a whole sector)
; X must point to the destination address where the Y bytes will be copied
;***************************************************************************************************
cpybuf   cmpu  #endbuf				; got to the end of buffer?
			bne   copym					; no, so copy data from buffer 
			pshs  x,y					; save parameters
			ldx   >sector				; get sector to read from
			cmpx  #$ffff				; reached end of table?
			beq   msgt3					; no more data to read. Problem!
			ldy   #strbuf				; point to beginning of circular buffer
			tfr   y,u					; copy buffer pointer to reg 'U'
			jsr   [dwdvet]				; ask DW4 to send a whole sector
			bcs   errdw 				; detect frame error
			bne   errdw 				; detect incomplete read operation
getsec	pshs  x						; save register X
			dec   <numsec				; decrement sectors in this extent
			ldb   <numsec				; get sectors left in this extent
			bne   nxtone				; if not zero, next one in that extent
nxtext   ldx   <tabptr				; get table pointer
         ldd	,x++					; get 1st LSN in next extent
         std   >sector				; put in variable
         lda   ,x+					; get number of sectors in this extent
         sta   <numsec				; put in variable
         stx   <tabptr				; update pointer
         bra   gets01				; out
nxtone   ldx	>sector				; get old LSN
			leax  1,x					; increment
			stx   >sector				; save next sector
gets01   puls  x						; restore X
			lda   #'.					; print dot
			jsr   outchr            ; to screen to show progress
			puls  x,y					; get parameters back
copym		lda   ,u+					; get a byte from buffer
			sta   ,x+					; copy at destination
			leay  -1,y					; decrement counter
			bne   cpybuf				; if not all done, keep on
			rts							; return

;***************************************************************************************************
endtab   FCN   /END OF TABLE/    	; reached end of Table			
endpgm   FCB   0							; end of of Program
;
